/**
 * Copyright (C) 2015 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {};

console.log("rich-editor");
RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

RE.commands = new Array('bold', 'italic','strikeThrough','underline','subscript','insertOrderedList','insertUnorderedList'
     ,'superscript','justifyCenter', 'justifyLeft', 'justifyRight');

RE.justifyWithCommands = new Array('strikeThrough','underline','bold', 'italic');

RE.AndroidVersion = 0;

RE.editor = document.getElementById('editor');
RE.title = document.getElementById('title_input_id');

document.addEventListener("selectionchange", function() {
              RE.backuprange();
              RE.getCommandState();

});

RE.setAndroidVersion = function(version){
  RE.AndroidVersion = version;
}

// Initializations
RE.callback = function() {
    console.log("callback_html: "+RE.getHtml());
    if (RE.AndroidVersion == 14 || RE.AndroidVersion == 15) {
        return;
    }

    window.location.href = "re-callback://" + encodeURIComponent(RE.getHtml());
    if (RE.editor.firstChild != undefined) {
      console.log("callback:"+ RE.editor.firstChild.tagName);
      if (RE.editor.firstChild.tagName != "P") {
          RE.editor.innerHTML = '<p>' + RE.editor.innerHTML + '</br></p>';
          console.log("callback:"+ RE.editor.innerHTML);
          RE.editor.style.paddingTop = 0;
          RE.selectNode(RE.editor.firstElementChild);

      }else{
        var p = RE.editor.firstElementChild;
        console.log(p.innerHTML);
        if (p.innerHTML == "" || p.innerHTML == undefined) {
          p.appendChild(document.createElement("br"));
        }
      }
    }else{
      console.log("callback:"+'<p>' + RE.editor.innerHTML + '</p>');
      RE.setHtml("<p></br></p>");
      RE.editor.style.paddingTop = 0;
      RE.selectNode(RE.editor.firstElementChild);
    }
}

RE.selectNode = function(node){
  var range = document.createRange();
  range.selectNode(node);
  range.collapse(false);
  var selection = window.getSelection();
  selection.removeAllRanges();
  selection.addRange(range);
  RE.getCommandState();
}

RE.setData = function(contents){
    RE.setHtml(contents);
    RE.contents = RE.getHtml();
}

RE.setHtml = function(contents) {
    removeLoading();
    Note.topDiv.style.display = "";
    if(Note.shouldShowLockIcon){
        document.getElementById("lock_img_id").style.display = "";
    }
    var content = decodeURIComponent(contents.replace(/\+/g, '%20'));
    RE.editor.innerHTML = content;
    console.log("setHtml:"+content);
    if (RE.editor.firstChild == undefined) {
      console.log("setHtml: firstChildName undefined");
      //RE.editor.innerHTML = "<p></br></p>";
    }

    if (RE.editor.firstChild != undefined) {
         console.log("setHtml: firstChildName:" + RE.editor.firstChild.tagName);
        if (RE.editor.firstChild.tagName == "P") {
          RE.editor.style.paddingTop = 0;
        }else{
          RE.editor.style.paddingTop = "16px";
        }
    }

    // var selection = window.getSelection();
    // var range = document.createRange();
    // range.selectNode(RE.editor.firstElementChild);
    // range.collapse(false);
    // selection.removeAllRanges();
    // selection.addRange(range);
    RE.editor.focus();

    RE.refreshImgClick();
}

RE.getHtml = function() {
    return RE.editor.innerHTML;
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setEditable = function(editable) {
    if (editable == "true") {
        RE.editor.style.webkitUserModify="read-write";
        RE.editor.addEventListener("input", RE.callback);
        Note.folderContainer.addEventListener('click', Note.selectNote);
    }else{
        RE.editor.style.webkitUserModify="read-only";
        RE.editor.removeEventListener("input", RE.callback);
        Note.title.readOnly = "readOnly";
        Note.title.style.display = "none";
        Note.titleP.style.display = "inline-block";
        Note.folderContainer.removeEventListener('click', Note.selectNote);
    }
}

RE.setFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    document.body.style.minHeight = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setContentEditable = function(editable) {
    Re.editor.contentEditable = editable;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
    RE.getCommandState();
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    console.log("setUnderline");
    document.execCommand('underline', false, null);
}

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    var arrayCommand = RE.beforeJustifyCommand();
    document.execCommand('justifyLeft', false, null);
    //RE.endJustifyCommand(arrayCommand);
    RE.getCommandState();
}

RE.setJustifyCenter = function() {
    var arrayCommand = RE.beforeJustifyCommand();
    if(document.queryCommandState("justifyCenter")){
      RE.setJustifyLeft();
    }else{
      document.execCommand('justifyCenter', false, null);
    }
    //RE.endJustifyCommand(arrayCommand);
    RE.getCommandState();
}

RE.setJustifyRight = function() {
    var arrayCommand = RE.beforeJustifyCommand();
    if(document.queryCommandState("justifyRight")){
      RE.setJustifyLeft();
    }else{
      document.execCommand('justifyRight', false, null);
    }

    //RE.endJustifyCommand(arrayCommand);
    RE.getCommandState();
}

RE.beforeJustifyCommand = function() {
  var array = new Array();
  for (var i = 0; i < RE.justifyWithCommands.length; i++) {
    var commandName = RE.justifyWithCommands[i];
    if (document.queryCommandState(commandName)) {
      array.push(commandName);
    }
  }

  return array;
}

RE.endJustifyCommand = function(arrayCommand){
  for (var i = 0; i < arrayCommand.length; i++) {
    var commandName = arrayCommand[i];
    console.log("endJustifyCommand:"+commandName);
    document.execCommand(commandName, false, null);
  }
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}

RE.insertImage = function(imgHtml) {
    console.log("imageHtml:"+imgHtml);
    RE.insertHTML(imgHtml);
    RE.refreshImgClick();
}

RE.replaceImageSrc = function(id, url) {
	console.log(document.getElementById(id).src);
	document.getElementById(id).src = url;
	console.log(document.getElementById(id).src);
}

RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length != 0) {
        if (sel.rangeCount) {
            var el = document.createElement("a");
            el.setAttribute("href", url);
            el.setAttribute("title", title);

            var range = sel.getRangeAt(0).cloneRange();
            range.surroundContents(el);
            sel.removeAllRanges();
            sel.addRange(range);
        }
    }
    RE.callback();
}

RE.insertUnOrderEdList = function() {
	  RE.restorerange();
    document.execCommand('insertunorderedlist');
}

RE.insertOrderEdList = function() {
   RE.restorerange();
   document.execCommand('insertorderedlist');
}

RE.getCommandState = function(){
  var info = {};
  info["bold"] = document.queryCommandState("bold");
  info["underline"] = document.queryCommandState("underline");
  info["italic"] = document.queryCommandState("italic");
  info["strikeThrough"] = document.queryCommandState("strikeThrough");
  info["insertOrderedList"] = document.queryCommandState("insertOrderedList");
  info["insertUnorderedList"] = document.queryCommandState("insertUnorderedList");
  info["justifyCenter"] = document.queryCommandState("justifyCenter");
  info["justifyLeft"] = document.queryCommandState("justifyLeft");
  info["justifyRight"] = document.queryCommandState("justifyRight");

  var jsonString = JSON.stringify(info);
  console.log("getCommandState"+jsonString);
  window.location.href = "re-command-state://" + jsonString;
  return jsonString;
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    var selection = window.getSelection();
    console.log("backuprange " + selection + " rangeCount:"+selection.rangeCount);
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};

      RE.printCurrentSelect(range);
    }
}

RE.printCurrentSelect = function(range){
  console.log("backuprange range:"+ range.startContainer + " offset:"+range.startOffset
+" endContainer:"+range.endContainer+" endOffset:"+range.endOffset);
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
    console.log("restorerange:" + selection + "rangeRange:"+range);
}

RE.removeFormat = function(){
    /*RE.setUnderline();
    RE.setStrikeThrough();
    document.execCommand('removeFormat', editor.getSelection().getNative());*/


    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        if (range.collapsed) {
          for (var i = 0; i < RE.justifyWithCommands.length; i++) {
              var commandName = RE.justifyWithCommands[i];
              console.log("commandName:"+commandName+" " + document.queryCommandState(commandName));
              if (document.queryCommandState(commandName)) {
                  document.execCommand(commandName, false, null);
                  if (document.queryCommandState(commandName)) {
                      document.execCommand(commandName, false, null);

                  }
                  console.log("true commandName:"+commandName + " " +document.queryCommandState(commandName));
              }
          }
        }
    }

    document.execCommand('removeFormat', false, null);
    RE.getCommandState();
}


RE.enabledEditingItems = function(e) {
    console.log("enabledEditingItems");
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    window.location.href = "re-state://" + encodeURI(items.join(','));
}

RE.focus = function() {
    /*var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.setStart(RE.editor, 0);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);*/
    RE.editor.focus();
}


RE.firstFocus = function() {
    console.log("firstFocus");
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(true);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    /*RE.editor.focus();*/
}

RE.testFocus = function() {
    console.log("testFocus");
    //var range = document.createRange();
    //range.selectNodeContents(RE.editor.firstElementChild);
    // range.collapse(false);
    // var selection = window.getSelection();
    // selection.removeAllRanges();
    // selection.addRange(range);
    /*RE.editor.focus();*/
}

RE.blurFocus = function() {
    RE.editor.blur();
}

// Event Listeners
RE.editor.addEventListener("input", RE.callback);
RE.editor.addEventListener("keyup", function(e) {
    var KEY_LEFT = 37, KEY_RIGHT = 39;
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
        RE.enabledEditingItems(e);
    }
});
RE.editor.addEventListener("click", RE.enabledEditingItems);
RE.editor.addEventListener("focus", RE.testFocus);

RE.refreshImgClick = function(){
     var img = RE.editor.getElementsByTagName("img");
     for(var n = 0; n < img.length; n++){
        console.log("add img event:"+img[n].getAttribute("src"));
        img[n].addEventListener('click', RE.imgClick);
     }
}

RE.imgClick = function(){
  console.log("img click:"+this + " parentCode:"+this.parentNode + " src:"+this.getAttribute("src"));
  RE.selectNode(this);
  if (window.NoteJs !== undefined) {
      window.NoteJs.onImgClick(this.getAttribute("src"));
  }
}
